<template>
  <div class="creating-group-chat">
    <ChatHeader
      margin-bottom-divider="0"
      class="create-chat-header"
    >
      <JText
        tag="h2"
        weight="normal"
        type="title-3"
        color="text"
      >
        {{ $t('new_group_users') }}
      </JText>
      <div class="create-chat-actions">
        <JButton
          icon
          size="s"
          color="gray"
          type="outlined"
          :title="$t('back_to_contacts')"
          @click="resetCreatingChat"
          @keydown.space="resetCreatingChat"
          @keydown.enter="resetCreatingChat"
        >
          <JIcon
            icon="close"
            size="14px"
          />
        </JButton>
        <JButton
          icon
          size="s"
          color="gray"
          type="outlined"
          :title="$t('back_to_contacts')"
          class="ml-1"
          @click="showCretingGroupChat"
          @keydown.space="resetCreatingChat"
          @keydown.enter="resetCreatingChat"
        >
          <JIcon icon="back" />
        </JButton>
        <JButton
          icon
          size="s"
          color="gray"
          type="outlined"
          :title="$t('back_to_contacts')"
          class="ml-1"
          @click="submitForm"
        >
          <JIcon
            icon="next"
            transform="rotate(180)"
          />
        </JButton>
      </div>
    </ChatHeader>

    <div class="creating-avatar-wrapper">
      <!-- <component
        :is="FileUpload"
        v-slot="fileUploadProps"
        @file-upload="setAvatar"
      >
        <JAvatarEditIcon v-bind="fileUploadProps">
          <template #default="avatarEditIconProps">
            <BaseImg
              v-bind="avatarEditIconProps"
              :src="avatarSrc"
            />
          </template>
        </JAvatarEditIcon>
      </component> -->

      <JTextField
        v-model="groupName"
        name="Group name"
        :placeholder="$t('group_name')"
        outlined
        regular
        class="mt-4"
      />
    </div>

    <div
      v-if="selectedUsers.length"
      class="selected-members-list"
    >
      <JText
        tag="p"
        type="text-1"
        color="secondary-title"
        weight="bold"
        class="members-label"
      >
        {{ selectedUsers.length }} {{ $t('members') }}
      </JText>
      <JList>
        <JListItem
          v-for="user in selectedUsers"
          :key="user.id"
          size="xl"
          :hover-effect="false"
        >
          <UserChatCard :user="user" hide-status />
        </JListItem>
      </JList>
    </div>
  </div>
</template>

<script setup lang="ts">
import { ref } from 'vue';
import { storeToRefs } from 'pinia';
import {
  JButton, JIcon, JAvatarEditIcon, JTextField, JList, JListItem, JText,
} from '@new-jira-clone/ui/src/components';
import { useUserStore } from '@new-jira-clone/libs/src/store';
import { UserChatCard } from '@/entities/User';
import { ChatHeader } from '@/shared';
import { useChatSocket } from '@/shared/api';
import useCreatingChatState from '../model/useCreatingChatState';

const { createGroupChat } = useChatSocket();
const { getUser } = storeToRefs(useUserStore());
const { $reset: resetCreatingChat, showCretingGroupChat, selectedUsers } = useCreatingChatState();

const defaultName = [getUser.value, ...selectedUsers.value]
  .map((user) => user?.name)
  .splice(0, 4)
  .join(', ');

const groupName = ref(defaultName);
const avatarSrc = ref('');

const submitForm = async () => {
  createGroupChat(
    [getUser.value, ...selectedUsers.value],
    {
      name: groupName.value === defaultName ? '' : groupName.value,
      avatar: avatarSrc.value,
    },
  );
  resetCreatingChat();
};

const setAvatar = (src: string) => {
  avatarSrc.value = src;
};
</script>

<style scoped lang="scss">
@use '@tools' as uiTools;

.creating-group-chat {
  display: flex;
  flex-direction: column;
  height: 100%;
  overflow: auto;
  @include uiTools.scrollbar;

  .create-chat-header {
    display: flex;
  }

  .create-chat-actions {
    display: flex;
  }

  .creating-avatar-wrapper {
    padding: 16px;
    background-color: #f5f5f5;
  }

  .selected-members-list {
    margin-top: 20px;
    background-color: var(--j-app-bg);
  }

  .members-label {
    margin-bottom: 4px;
    padding: 0 16px;
  }
}
</style>
